diff --git a/web/pgadmin/browser/server_groups/servers/tests/test_server_put.py b/web/pgadmin/browser/server_groups/servers/tests/test_server_put.py
index 303d14e1..e3fe2c85 100644
--- a/web/pgadmin/browser/server_groups/servers/tests/test_server_put.py
+++ b/web/pgadmin/browser/server_groups/servers/tests/test_server_put.py
@@ -9,35 +9,43 @@
 
 import json
 
-from pgadmin.utils.route import BaseTestGenerator
+from grappa import should
+
 from regression.python_test_utils import test_utils as utils
 
 
-class ServerUpdateTestCase(BaseTestGenerator):
-    """ This class will update server's comment field. """
+class TestServersPut:
+    def test_server_put(self, request, context_of_tests):
+        """
+        When sending put request to server url
+        It returns 200 status code
+        """
+
+        request.addfinalizer(self.tearDown)
 
-    scenarios = [
-        # Fetching the default url for server node
-        ('Default Server Node url', dict(url='/browser/server/obj/'))
-    ]
+        url = '/browser/server/obj/'
+        server = context_of_tests['server']
+        self.server_id = utils.create_server(server)
+        if not self.server_id:
+            raise Exception("Server not found to test GET API")
 
-    def setUp(self):
-        """This function add the server to test the PUT API"""
-        self.server_id = utils.create_server(self.server)
+        self.tester = context_of_tests['test_client']
         server_dict = {"server_id": self.server_id}
         utils.write_node_info("sid", server_dict)
 
-    def runTest(self):
-        """This function update the server details"""
-        if not self.server_id:
-            raise Exception("No server to update.")
-        data = {"comment": self.server['comment'], "id": self.server_id}
-        put_response = self.tester.put(
-            self.url + str(utils.SERVER_GROUP) + '/' +
-            str(self.server_id), data=json.dumps(data),
-            content_type='html/json')
-        self.assertEquals(put_response.status_code, 200)
+        data = {
+            "comment": server['comment'],
+            "id": self.server_id
+        }
+
+        response = self.tester.put(
+            url + str(utils.SERVER_GROUP) + '/' +
+            str(self.server_id),
+            data=json.dumps(data),
+            content_type='html/json'
+        )
+
+        response.status_code | should.be.equal.to(200)
 
     def tearDown(self):
-        """This function delete the server from SQLite"""
         utils.delete_server_with_api(self.tester, self.server_id)
diff --git a/web/pgadmin/browser/server_groups/tests/__init__.py b/web/pgadmin/browser/server_groups/tests/__init__.py
index 21b02cad..590026ad 100644
--- a/web/pgadmin/browser/server_groups/tests/__init__.py
+++ b/web/pgadmin/browser/server_groups/tests/__init__.py
@@ -6,10 +6,3 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-
-from pgadmin.utils.route import BaseTestGenerator
-
-
-class SGGenerateTestCase(BaseTestGenerator):
-    def runTest(self):
-        return
diff --git a/web/pgadmin/browser/server_groups/tests/test_sg_get.py b/web/pgadmin/browser/server_groups/tests/test_sg_get.py
index def75a7b..a49b87b5 100644
--- a/web/pgadmin/browser/server_groups/tests/test_sg_get.py
+++ b/web/pgadmin/browser/server_groups/tests/test_sg_get.py
@@ -9,26 +9,25 @@
 
 import json
 
-from pgadmin.utils.route import BaseTestGenerator
-from regression.test_setup import config_data
+from grappa import should
 
+from regression.test_setup import config_data
 
-class SgNodeTestCase(BaseTestGenerator):
-    """
-     This class will check available server groups in pgAdmin.
-    """
 
-    scenarios = [
-        # Fetching the default url for server group node
-        ('Check Server Group Node', dict(url='/browser/server_group/obj/'))
-    ]
+class TestServerGroupNode:
+    def test_server_group_node(self, context_of_tests):
+        """
+        When a get request is made to the server group endpoint
+        It returns status 200 and the server group
+        """
 
-    def runTest(self):
-        """This function will check available server groups."""
+        url = '/browser/server_group/obj/'
+        http_client = context_of_tests['test_client']
 
         server_group_id = config_data['server_group']
-        response = self.tester.get(self.url + str(server_group_id),
+        response = http_client.get(url + str(server_group_id),
                                    content_type='html/json')
-        self.assertTrue(response.status_code, 200)
+
+        response.status_code | should.equal(200)
         response_data = json.loads(response.data.decode('utf8'))
-        self.assertTrue(response_data['id'], server_group_id)
+        response_data['id'] | should.equal(server_group_id)
diff --git a/web/pgadmin/browser/tests/__init__.py b/web/pgadmin/browser/tests/__init__.py
index 7ce53131..590026ad 100644
--- a/web/pgadmin/browser/tests/__init__.py
+++ b/web/pgadmin/browser/tests/__init__.py
@@ -6,10 +6,3 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
-
-from pgadmin.utils.route import BaseTestGenerator
-
-
-class BrowserGenerateTestCase(BaseTestGenerator):
-    def runTest(self):
-        return
diff --git a/web/pgadmin/browser/tests/test_change_password.py b/web/pgadmin/browser/tests/test_change_password.py
index 5b337db7..3fef2446 100644
--- a/web/pgadmin/browser/tests/test_change_password.py
+++ b/web/pgadmin/browser/tests/test_change_password.py
@@ -10,125 +10,171 @@
 import json
 import uuid
 
-from pgadmin.utils.route import BaseTestGenerator
+import pytest
+from grappa import should
+
 from regression.python_test_utils import test_utils
 from regression.test_setup import config_data
-from . import utils
 
 
-class ChangePasswordTestCase(BaseTestGenerator):
-    """
-    This class validates the change password functionality
-    by defining change password scenarios; where dict of
-    parameters describes the scenario appended by test name.
-    """
+@pytest.mark.skip_if_not_in_server_mode
+class TestChangePassword(object):
+    def test_incorrect_password(self, request, context_of_tests):
+        """
+        When trying to change the password
+        And the confirmation password does not match
+        It returns "Passwords do not match" error
+        """
+        http_client = context_of_tests['test_client']
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
 
-    scenarios = [
-        # This testcase validates invalid confirmation password
-        ('TestCase for Validating Incorrect_New_Password', dict(
-            password=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_password']),
-            new_password=(
-                config_data['pgAdmin4_login_credentials']
-                ['new_password']),
-            new_password_confirm=str(uuid.uuid4())[4:8],
-            respdata='Passwords do not match')),
+        response = http_client.post(
+            '/browser/change_password',
+            data=dict(
+                password=config_data['pgAdmin4_login_credentials']
+                ['login_password'],
+                new_password=str(uuid.uuid4())[4:8],
+                new_password_confirm=str(uuid.uuid4())[4:8]
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf-8') | should.contain(
+            'Passwords do not match')
 
-        # This testcase validates if confirmation password is less than
-        # minimum length
-        ('TestCase for Validating New_Password_Less_Than_Min_Length',
-         dict(password=(
-             config_data['pgAdmin4_login_credentials']
-             ['login_password']),
-             new_password=str(uuid.uuid4())[4:8],
-             new_password_confirm=str(uuid.uuid4())[4:8],
-             respdata='Password must be at least 6 characters')),
+    def test_minimum_length(self, request, context_of_tests):
+        """
+        When trying to change the password
+        And has less then 6 characters
+        It returns "Password not provided" error
+        """
+        http_client = context_of_tests['test_client']
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
 
-        # This testcase validates if both password fields are left blank
-        ('TestCase for Validating Empty_New_Password', dict(
-            password=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_password']),
-            new_password='', new_password_confirm='',
-            respdata='Password not provided')),
+        response = http_client.post(
+            '/browser/change_password',
+            data=dict(
+                password=config_data['pgAdmin4_login_credentials']
+                ['login_password'],
+                new_password='pgadm',
+                new_password_confirm='pgadm'
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf-8') | should.contain(
+            'Password must be at least 6 characters')
 
-        # This testcase validates if current entered password is incorrect
-        ('TestCase for Validating Incorrect_Current_Password', dict(
-            password=str(uuid.uuid4())[4:8],
-            new_password=(
-                config_data['pgAdmin4_login_credentials']
-                ['new_password']),
-            new_password_confirm=(
-                config_data['pgAdmin4_login_credentials']
-                ['new_password']),
-            respdata='Invalid password')),
+    def test_no_new_password_provided(self, request, context_of_tests):
+        """
+        When trying to change the password
+        And password and confirmation password are empty
+        It returns "Password not provided" error
+        """
+        http_client = context_of_tests['test_client']
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
 
-        # This test case checks for valid password
-        ('TestCase for Changing Valid_Password', dict(
-            valid_password='reassigning_password',
-            username=(
-                config_data['pgAdmin4_test_user_credentials']
-                ['login_username']),
-            password=(
-                config_data['pgAdmin4_test_user_credentials']
-                ['login_password']),
-            new_password=(
-                config_data['pgAdmin4_test_user_credentials']
-                ['new_password']),
-            new_password_confirm=(
-                config_data['pgAdmin4_test_user_credentials']
-                ['new_password']),
-            respdata='You successfully changed your password.'))
-    ]
+        response = http_client.post(
+            '/browser/change_password',
+            data=dict(
+                password=config_data['pgAdmin4_login_credentials']
+                ['login_password'],
+                new_password='',
+                new_password_confirm=''
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf-8') | should.contain(
+            'Password not provided')
 
-    @classmethod
-    def setUpClass(cls):
-        pass
+    def test_current_password_is_incorrect(self, request, context_of_tests):
+        """
+        When trying to change the password
+        And current password provided is not correct
+        It returns "Invalid password" error
+        """
+        http_client = context_of_tests['test_client']
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
 
-    def runTest(self):
-        """This function will check change password functionality."""
+        response = http_client.post(
+            '/browser/change_password',
+            data=dict(
+                password=str(uuid.uuid4())[4:8],
+                new_password='asdfasdf',
+                new_password_confirm='asdfasdf'
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf-8') | should.contain(
+            'Invalid password')
 
-        # Check for 'valid_password' exists in self to test 'valid password'
-        # test case
-        if 'valid_password' in dir(self):
-            response = self.tester.post(
-                '/user_management/user/',
-                data=dict(
-                    email=self.username,
-                    newPassword=self.password,
-                    confirmPassword=self.password,
-                    active=1,
-                    role="2"
-                ),
-                follow_redirects=True
-            )
-            user_id = json.loads(response.data.decode('utf-8'))['id']
-            # Logout the Administrator before login normal user
-            test_utils.logout_tester_account(self.tester)
-            response = self.tester.post(
-                '/login',
-                data=dict(
-                    email=self.username,
-                    password=self.password
-                ),
-                follow_redirects=True
-            )
-            self.assertEquals(response.status_code, 200)
-            # test the 'change password' test case
-            utils.change_password(self)
-            # Delete the normal user after changing it's password
-            test_utils.logout_tester_account(self.tester)
-            # Login the Administrator before deleting normal user
-            test_utils.login_tester_account(self.tester)
-            response = self.tester.delete(
-                '/user_management/user/' + str(user_id),
-                follow_redirects=True
-            )
-            self.assertEquals(response.status_code, 200)
-        else:
-            utils.change_password(self)
+    @pytest.mark.xfail(reason='Test previously failing, the login does not go '
+                       'through successfuly')
+    def test_success(self, request, context_of_tests):
+        """
+        When trying to change the password
+        And everything is correct
+        It returns changes the password
+        """
+        http_client = context_of_tests['test_client']
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
+        response = http_client.post(
+            '/user_management/user/',
+            data=dict(
+                email=config_data['pgAdmin4_test_user_credentials']
+                ['login_username'] + '1',
+                newPassword=config_data['pgAdmin4_test_user_credentials']
+                ['login_password'],
+                confirmPassword=config_data['pgAdmin4_test_user_credentials']
+                ['login_password'],
+                active=1,
+                role="2"
+            ),
+            follow_redirects=True
+        )
 
-    @classmethod
-    def tearDownClass(cls):
-        test_utils.login_tester_account(cls.tester)
+        json.loads(response.data.decode('utf-8')) | should.have.key('id')
+        user_id = json.loads(response.data.decode('utf-8'))['id']
+        # Logout the Administrator before login normal user
+        test_utils.logout_tester_account(http_client)
+        response = http_client.post(
+            '/login',
+            data=dict(
+                email=config_data['pgAdmin4_test_user_credentials']
+                ['login_username'] + '1',
+                password=config_data['pgAdmin4_test_user_credentials']
+                ['login_password']
+            ),
+            follow_redirects=True
+        )
+        response.status_code | should.be.equal(200)
+        response = http_client.get(
+            '/browser/change_password', follow_redirects=True
+        )
+        response.data.decode('utf-8') | should.contain(
+            'pgAdmin 4 Password Change')
+        # test the 'change password' test case
+        response = http_client.post(
+            '/browser/change_password',
+            data=dict(
+                password=config_data['pgAdmin4_test_user_credentials']
+                ['login_password'],
+                new_password='asdfasdf',
+                new_password_confirm='asdfasdf'
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf-8') | should.contain(
+            'You successfully changed your password')
+        # Delete the normal user after changing it's password
+        test_utils.logout_tester_account(http_client)
+        # Login the Administrator before deleting normal user
+        test_utils.login_tester_account(http_client)
+        response = http_client.delete(
+            '/user_management/user/' + str(user_id),
+            follow_redirects=True
+        )
+        response.status_code | should.be.equal(200)
diff --git a/web/pgadmin/browser/tests/test_gravatar_image_display.py b/web/pgadmin/browser/tests/test_gravatar_image_display.py
index a4526c9d..221db63b 100644
--- a/web/pgadmin/browser/tests/test_gravatar_image_display.py
+++ b/web/pgadmin/browser/tests/test_gravatar_image_display.py
@@ -6,63 +6,38 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
+import pytest
+from grappa import should
 
 import config
-from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils as utils
 from regression.test_setup import config_data as tconfig
 
 
-class TestLoginUserImage(BaseTestGenerator):
-    """
-    This class checks for user image after successful login.
-    - If SHOW_GRAVATAR_IMAGE config option is set to True then we will show
-    Gravatar on the Page.
-    - If SHOW_GRAVATAR_IMAGE config option is set to False then we will show
-    Static image on the Page.
-    """
-
-    scenarios = [
-        (
-            'Verify gravatar image on the page', dict(
-                email=(
-                    tconfig['pgAdmin4_login_credentials']['login_username']
-                ),
-                password=(
-                    tconfig['pgAdmin4_login_credentials']['login_password']
-                ),
-                respdata='Gravatar image for %s' %
-                         tconfig['pgAdmin4_login_credentials']
-                         ['login_username'],
-            )
-        )
-    ]
-
-    @classmethod
-    def setUpClass(cls):
-        "Logout first if already logged in"
-        utils.logout_tester_account(cls.tester)
+class TestGravatarImageDisplay(object):
+    @pytest.mark.skip_if_not_in_server_mode
+    def test_gravatar_image_display(self, request, context_of_tests):
+        """
+        When user login
+        It displays the gravatar
+        """
+        http_client = context_of_tests['test_client']
+        utils.logout_tester_account(http_client)
+        request.addfinalizer(lambda: utils.login_tester_account(http_client))
 
-    def runTest(self):
-        # Login and check type of image in response
-        response = self.tester.post(
+        response = http_client.post(
             '/login', data=dict(
-                email=self.email,
-                password=self.password
+                email=tconfig['pgAdmin4_login_credentials']['login_username'],
+                password=tconfig['pgAdmin4_login_credentials'][
+                    'login_password']
             ),
             follow_redirects=True
         )
-        # Should have gravatar image
+        gravatar_information = 'Gravatar image for {0}'.format(
+            tconfig['pgAdmin4_login_credentials']['login_username']
+        )
         if config.SHOW_GRAVATAR_IMAGE:
-            self.assertIn(self.respdata, response.data.decode('utf8'))
-        # Should not have gravatar image
+            response.data.decode('utf8') | should.contain(gravatar_information)
         else:
-            self.assertNotIn(self.respdata, response.data.decode('utf8'))
-
-    @classmethod
-    def tearDownClass(cls):
-        """
-        We need to again login the test client as soon as test scenarios
-        finishes.
-        """
-        utils.login_tester_account(cls.tester)
+            response.data.decode('utf8') | should.not_contain(
+                gravatar_information)
diff --git a/web/pgadmin/browser/tests/test_login.py b/web/pgadmin/browser/tests/test_login.py
index d830dfbc..18f2df8f 100644
--- a/web/pgadmin/browser/tests/test_login.py
+++ b/web/pgadmin/browser/tests/test_login.py
@@ -9,99 +9,127 @@
 
 import uuid
 
-from pgadmin.utils.route import BaseTestGenerator
-from regression.python_test_utils import test_utils as utils
+import pytest
+from grappa import should
+
+from regression.python_test_utils import test_utils
 from regression.test_setup import config_data
 
 
-class LoginTestCase(BaseTestGenerator):
-    """
-    This class checks login functionality by validating different scenarios.
-    Login scenarios are defined in dictionary; where dict of parameters
-    describe the scenario appended by test name.
-    """
-
-    scenarios = [
-        # This test case validates the invalid/incorrect password
-        ('TestCase for Checking Invalid_Password', dict(
-            email=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_username']),
-            password=str(uuid.uuid4())[4:8],
-            respdata='Invalid password')),
-
-        # This test case validates the empty password field
-        ('Empty_Password', dict(
-            email=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_username']), password='',
-            respdata='Password not provided')),
-
-        # This test case validates blank email field
-        ('Empty_Email', dict(
-            email='', password=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_password']),
-            respdata='Email not provided')),
-
-        # This test case validates empty email and password
-        ('Empty_Credentials', dict(
-            email='', password='',
-            respdata='Email not provided')),
-
-        # This test case validates the invalid/incorrect email id
-        ('Invalid_Email', dict(
-            email=str(uuid.uuid4())[1:8] + '@xyz.com',
-            password=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_password']),
-            respdata='Specified user does not exist')),
-
-        # This test case validates invalid email and password
-        ('Invalid_Credentials', dict(
-            email=str(uuid.uuid4())[1:8] + '@xyz.com',
-            password=str(uuid.uuid4())[4:8],
-            respdata='Specified user does not exist')),
-
-        # This test case validates the valid/correct credentials and allow user
-        # to login pgAdmin 4
-        ('Valid_Credentials', dict(
-            email=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_username']),
-            password=(
-                config_data['pgAdmin4_login_credentials']
-                ['login_password']),
-            respdata='Gravatar image for %s' %
-                     config_data['pgAdmin4_login_credentials']
-                     ['login_username']))
-    ]
-
-    @classmethod
-    def setUpClass(cls):
+@pytest.mark.skip_if_not_in_server_mode
+class TestLogin(object):
+    def test_incorrect_password(self, request, context_of_tests):
+        """
+        When trying to login
+        And password is invalid
+        It returns "Invalid password" error
+        """
+        http_client = context_of_tests['test_client']
+
+        test_utils.logout_tester_account(http_client)
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
+
+        response = http_client.post(
+            '/login',
+            data=dict(
+                email=config_data['pgAdmin4_login_credentials']
+                ['login_username'],
+                password=str(uuid.uuid4())[4:8]
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf8') | should.contain('Invalid password')
+
+    def test_empty_email(self, request, context_of_tests):
         """
-        We need to logout the test client as we are testing scenarios of
-        logging in the client like invalid password, invalid emails,
-        empty credentials etc.
+        When trying to login
+        And email is empty
+        It returns "Email not provided" error
         """
-        utils.logout_tester_account(cls.tester)
+        http_client = context_of_tests['test_client']
+
+        test_utils.logout_tester_account(http_client)
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
 
-    def runTest(self):
-        """This function checks login functionality."""
-        response = self.tester.post(
+        response = http_client.post(
             '/login',
             data=dict(
-                email=self.email,
-                password=self.password
+                email='',
+                password=str(uuid.uuid4())[4:8]
             ),
             follow_redirects=True
         )
-        self.assertTrue(self.respdata in response.data.decode('utf8'))
+        response.data.decode('utf8') | should.contain('Email not provided')
 
-    @classmethod
-    def tearDownClass(cls):
+    def test_empty_password(self, request, context_of_tests):
         """
-        We need to again login the test client as soon as test scenarios
-        finishes.
+        When trying to login
+        And password is empty
+        It returns "Password not provided" error
         """
-        utils.login_tester_account(cls.tester)
+        http_client = context_of_tests['test_client']
+
+        test_utils.logout_tester_account(http_client)
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
+
+        response = http_client.post(
+            '/login',
+            data=dict(
+                email=str(uuid.uuid4())[4:8],
+                password=''
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf8') | should.contain('Password not provided')
+
+    def test_user_not_found(self, request, context_of_tests):
+        """
+        When trying to login
+        And the user does not exist
+        It returns "Specified user does not exist" error
+        """
+        http_client = context_of_tests['test_client']
+
+        test_utils.logout_tester_account(http_client)
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
+
+        response = http_client.post(
+            '/login',
+            data=dict(
+                email=str(uuid.uuid4())[4:8] + '@xyz.com',
+                password=str(uuid.uuid4())[4:8]
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf8') | should.contain(
+            'Specified user does not exist')
+
+    def test_success(self, request, context_of_tests):
+        """
+        When trying to login
+        And the credential are correct
+        It returns "Specified user does not exist" error
+        """
+        http_client = context_of_tests['test_client']
+
+        test_utils.logout_tester_account(http_client)
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
+
+        response = http_client.post(
+            '/login',
+            data=dict(
+                email=config_data['pgAdmin4_login_credentials']
+                ['login_username'],
+                password=config_data['pgAdmin4_login_credentials']
+                ['login_password']
+            ),
+            follow_redirects=True
+        )
+        response.data.decode('utf8') | should.contain(
+            'Gravatar image for %s' % config_data['pgAdmin4_login_credentials']
+                                                 ['login_username'])
diff --git a/web/pgadmin/browser/tests/test_logout.py b/web/pgadmin/browser/tests/test_logout.py
index 51c206f4..409110ec 100644
--- a/web/pgadmin/browser/tests/test_logout.py
+++ b/web/pgadmin/browser/tests/test_logout.py
@@ -6,38 +6,22 @@
 # This software is released under the PostgreSQL Licence
 #
 ##########################################################################
+import pytest
+from grappa import should
 
+from regression.python_test_utils import test_utils
 
-from pgadmin.utils.route import BaseTestGenerator
-from regression.python_test_utils import test_utils as utils
 
-
-class LogoutTest(BaseTestGenerator):
-    """
-    This class verifies the logout functionality; provided the user is already
-    logged-in. Dictionary parameters define the scenario appended by test
-    name.
-    """
-
-    scenarios = [
-        # This test case validate the logout page
-        ('Logging Out', dict(respdata='Redirecting...'))
-    ]
-
-    @classmethod
-    def setUpClass(cls):
-        pass
-
-    def runTest(self):
-        """This function checks the logout functionality."""
-
-        response = self.tester.get('/logout')
-        self.assertTrue(self.respdata in response.data.decode('utf8'))
-
-    @classmethod
-    def tearDownClass(cls):
+@pytest.mark.skip_if_not_in_server_mode
+class TestLogout(object):
+    def test_success(self, request, context_of_tests):
         """
-        We need to again login the test client as soon as test scenarios
-        finishes.
+        When trying to logout
+        And the credential are correct
+        It returns "Specified user does not exist" error
         """
-        utils.login_tester_account(cls.tester)
+        http_client = context_of_tests['test_client']
+        response = http_client.get('/logout')
+        request.addfinalizer(lambda: test_utils
+                             .login_tester_account(http_client))
+        response.data.decode('utf8') | should.contain('Redirecting...')
